#pragma once 
#include "ADSLibrary\DataStructures\LinkedStructures\OOP\Queue.h"

class GraphInMartix
{
private:
	int** graph;
	int vertexCount;
	bool* visited;
public:
	GraphInMartix(int NoOfNodes)
	{
		vertexCount = NoOfNodes;
		graph = new int*[vertexCount + 1];
		for (int i = 1; i < (vertexCount + 1); i++)
		{
			graph[i] = new int[vertexCount + 1];
			for (int j = 1; j < (vertexCount + 1); j++)
				graph[i][j] = 0;
		}
		visited = new bool[vertexCount + 1];
		resetVisited();
	}

	~GraphInMartix()
	{
		for (int i = 1; i < (vertexCount + 1); i++)
			delete[] graph[i];
		delete[] graph;
		delete[] visited;
	}

	void AddEdge(int a, int b)
	{
		graph[a][b] = 1;
		graph[b][a] = 1;
	}

	void report()
	{
		cout << "Graf v matici na " << vertexCount << " vrcholech" << endl;
		cout << "hrany: " << endl;
		for (int i = 1; i < (vertexCount + 1); i++)
			for (int j = i + 1; j < (vertexCount + 1); j++) //j zacina na i+1 - prochazime jen cast matice nad diagonalou, tedy vypisujeme hrany jen jednou
				if (graph[i][j])
					cout << "hrana z: " << i << " do: " << j << endl;
	}

	void resetVisited()
	{
		for (int i = 1; i < (vertexCount + 1); i++)
			visited[i] = false;
	}

	void DFSV(int vertex)
	{
		cout << "nalezen vrchol: " << vertex << endl;
		visited[vertex] = true;
		for (int i = 1; i < (vertexCount + 1); i++)//prochazime cely radek incidencni matice
		{
			if (graph[vertex][i] && !visited[i])//pokud je na danem miste ulozena nenulova hodnota, vrchnol je soused
				DFSV(i);
		}
	}

	void BFS(int vertex)
	{
		ADSLibrary::DataStructures::LinkedStructures::OOP::Queue foundVertexes;

		cout << "nalezen vrchol: " << vertex << endl;
		visited[vertex] = true;

		foundVertexes.Enqueue(vertex);
		int found;

		while (!foundVertexes.IsEmpty())
		{
			found = foundVertexes.Dequeue();
			
			for (int i = 1; i < (vertexCount + 1); i++)
			{
				if (graph[found][i] && !visited[i])
				{
					cout << "nalezen vrchol: " << i << endl;
					visited[i] = true;
					foundVertexes.Enqueue(i);
				}
			}

		}
	}
};